# ifndef UNPACKOPERS_H
# define UNPACKOPERS_H

#include "../Adapter.h"
#include <string>
#include <sstream>
#include <algorithm>
#include "../ExcelDoNotEdit/excel_addin_utils.h"
#include <vector>


int unpack_int(XLOPER12* in_oper, unsigned int argnumber);
double unpack_double(XLOPER12* in_oper, unsigned int argnumber);
std::string unpack_string(XLOPER12* in_oper, unsigned int argnumber);
excel_adapter::d_vector unpack_double_vector(XLOPER12* in_oper, unsigned int argnumber);
excel_adapter::d_matrix unpack_double_matrix(XLOPER12* in_oper, unsigned int argnumber);

void pack_double_oper(double indouble, XLOPER12* xl_function_result);
void pack_int_oper(int inint, XLOPER12* xl_function_result);
void pack_double_vector_oper(const excel_adapter::d_vector& invector, XLOPER12* xl_function_result);
void pack_double_matrix_oper(const excel_adapter::d_matrix& inmatrix, XLOPER12* xl_function_result);

#endif
